%define upstream_name    Devel-TraceUse
%define upstream_version 2.097

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 1

Summary:    Hack around calling UNIVERSAL::can() as a function
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        https://metacpan.org/release/%{upstream_name}
Source0:    https://cpan.metacpan.org/authors/id/B/BO/BOOK/%{upstream_name}-%{upstream_version}.tar.gz

BuildRequires: perl(Data::Dumper)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(File::Spec)
BuildRequires: perl(IO::Handle)
BuildRequires: perl(IPC::Open3)
BuildRequires: perl(Module::CoreList)
BuildRequires: perl(Test::More)
BuildRequires: perl(lib)
BuildRequires: perl(strict)
BuildRequires: perl(warnings)
BuildArch:  noarch

%description
The UNIVERSAL class provides a few default methods so that all objects can use
them. Object orientation allows programmers to override these methods in
subclasses to provide more specific and appropriate behavior.

Some authors call methods in the UNIVERSAL class on potential invocants as
functions, bypassing any possible overriding. This is wrong and you should not
do it. Unfortunately, not everyone heeds this warning and their bad code can
break your good code.

Fortunately, this upstream_name replaces UNIVERSAL::can() with a method that checks to
see if the first argument is a valid invocant (whether an object -- a blessed
referent -- or the name of a class). If so, and if the invocant's class has its
own can() method, it calls that as a method. Otherwise, everything works as you
might expect.

If someone attempts to call UNIVERSAL::can() as a function, this upstream_name will
emit a lexical warning (see perllexwarn) to that effect. You can disable it
with no warnings; or no warnings 'UNIVERSAL::isa';, but don't do that; fix the
code instead.

%prep
%setup -q -n %{upstream_name}-%{upstream_version}

%build
%__perl Makefile.PL INSTALLDIRS=vendor
%make_build

%check
%make_build test

%install
%make_install

%files 
%doc Changes LICENSE META.json META.yml MYMETA.yml README
%{perl_vendorlib}/*
%{_mandir}/*/*

%changelog
* Mon Jan 09 2023 tv <tv> 2.97.0-1.mga9
+ Revision: 1931847
- update to 2.097

* Mon Mar 21 2022 umeabot <umeabot> 2.96.0-3.mga9
+ Revision: 1811239
- Mageia 9 Mass Rebuild

* Fri Feb 14 2020 umeabot <umeabot> 2.96.0-2.mga8
+ Revision: 1521735
- Mageia 8 Mass Rebuild

* Mon Dec 31 2018 tv <tv> 2.96.0-1.mga7
+ Revision: 1347297
- new release

* Thu Sep 20 2018 umeabot <umeabot> 2.95.0-3.mga7
+ Revision: 1282882
- Mageia 7 Mass Rebuild

* Mon Oct 02 2017 tv <tv> 2.95.0-2.mga7
+ Revision: 1164068
- rebuild with fixed rpm for missing autodeps

* Tue Sep 19 2017 sander85 <sander85> 2.95.0-1.mga7
+ Revision: 1155529
- update to 2.095
- update to 2.095

* Sun Jun 19 2016 pterjan <pterjan> 2.94.0-2.mga6
+ Revision: 1025651
- Rebuild for perl 5.22.2

* Fri Apr 15 2016 shlomif <shlomif> 2.94.0-1.mga6
+ Revision: 1001838
- update to 2.094

* Fri Feb 19 2016 umeabot <umeabot> 2.93.0-5.mga6
+ Revision: 970240
- Mageia 6 Mass Rebuild

* Wed Sep 30 2015 sander85 <sander85> 2.93.0-4.mga6
+ Revision: 885408
- Fix BRs

* Wed Oct 15 2014 umeabot <umeabot> 2.93.0-3.mga5
+ Revision: 739938
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 2.93.0-2.mga5
+ Revision: 684340
- Mageia 5 Mass Rebuild

* Fri Jun 27 2014 sander85 <sander85> 2.93.0-1.mga5
+ Revision: 640334
- update to 2.093

* Sat May 17 2014 sander85 <sander85> 2.92.0-1.mga5
+ Revision: 623239
- Fix BR
+ jquelin <jquelin>
- update to 2.092

* Sat Oct 19 2013 umeabot <umeabot> 2.90.0-2.mga4
+ Revision: 526883
- Mageia 4 Mass Rebuild

* Fri Jun 07 2013 jquelin <jquelin> 2.90.0-1.mga4
+ Revision: 439039
- update to 2.09

* Sun Jan 13 2013 umeabot <umeabot> 2.80.0-2.mga3
+ Revision: 365834
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 17 2012 jquelin <jquelin> 2.80.0-1.mga3
+ Revision: 294956
- update to 2.08

* Wed Jan 25 2012 jquelin <jquelin> 2.60.0-1.mga2
+ Revision: 200851
- update to 2.06

* Tue Apr 19 2011 jquelin <jquelin> 2.50.0-1.mga1
+ Revision: 88510
- update to 2.05

* Fri Jan 21 2011 jquelin <jquelin> 2.30.0-1.mga1
+ Revision: 28489
- mageia rebuild
- cleaning spec file
- imported package perl-Devel-TraceUse

